# Hardhat

### What is Hardhat?

Hardhat is a development environment for Ethereum that helps developers manage and automate the common tasks involved in building smart contracts and decentralized applications. It can directly interact with Alpha Dune's Ethereum API, allowing for the deployment of smart contracts into the Alpha Dune network.

\
Additionally, Hardhat is a comprehensive set of tools for creating Ethereum-based software, which includes various components that aid in editing, compiling, debugging, and deploying smart contracts and decentralized applications. All of these components work together to create a complete development environment.

### Creating a Hardhat Project <a href="#creating-a-hardhat-project" id="creating-a-hardhat-project"></a>

1. Create a directory for your project:

```
mkdir hardhat && cd hardhat
```

2. Initialize the project, which will create a `package.json` file

```
npm init -y
```

3. Install Hardhat

```
npm install hardhat
```

4. Create project

```
npx hardhat
```

5. Create an empty `hardhat.config.js` and install the Ethers plugin to use the Ethers.js library to interact with the network.

```
npm install @nomiclabs/hardhat-ethers ethers
```

### Creating Your Smart Contract

1. Create a `contracts` directory

```
mkdir contracts && cd contracts
```

2. Create `your_contract.sol` file in `contracts` directory

```javascript
touch your_contract.sol
```

### Creating Your Configuration File

Modify the Hardhat configuration file and create a secure file to store your private key in.

1. Create a `secrets.json` file to store your private key

```javascript
touch secrets.json
```

2. Add your private key to `secrets.json`

```javascript
{
    "privateKey": "YOUR-PRIVATE-KEY-HERE"
}
```

3. Add the file to your project’s `.gitignore`, and never reveal your private key.
4. Modify the `hardhat.config.js` file

* Import the `Ethers.js` plugin
* Import the `secrets.json` file
* Inside the `module.exports` add the Caldera network configuration

{% code title="hardhat.config.js" %}

```javascript
require('@nomiclabs/hardhat-ethers');
const { privateKey } = require('./secrets.json');

module.exports = {
solidity: "0.8.1",
defaultNetwork: "rinkeby",
networks: {
    rinkeby: {
    url: "https://eth-rinkeby.alchemyapi.io/v2/123abc123abc123abc123abc123abcde",
    accounts: [privateKey]
    },
    caldera: {
    url: "RPC URL",  // Insert your RPC URL Here
    chainId: CHAINID, //Insert your ChainID Here
    }
},
}
```

{% endcode %}

### Deploying Your Smart Contract

1. Compile the contract

```
npx hardhat compilejs
```

2. Create a new directory for the script and name it scripts and add a new file to it called `deploy.js`

```
mkdir scripts && cd scripts
touch deploy.js
```

3. Create a deployment script, like the one below

{% code title="scripts/deploy.js" %}

```javascript
async function main() {
// 1. Get the contract to deploy
const Your_Contract = await ethers.getContractFactory('your_contract');
console.log('Deploying Your_Contract...');

// 2. Instantiating a new smart contract
const your_contract = await Your_Contract.deploy();

// 3. Waiting for the deployment to resolve
await your_contract.deployed();

// 4. Use the contract instance to get the contract address
console.log('Your_Contract deployed to:', your_contract.address);
}

main()
.then(() => process.exit(0))
.catch((error) => {
    console.error(error);
    process.exit(1);
});

```

{% endcode %}

4. Deploy `your_contract.sol` using the command below

```
npx hardhat run scripts/deploy.js --network caldera
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.alphadune.com/alpha-dune-network/hardhat.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
